Subject: RE: S/MIME support in X.400

From: "Hegde, Vijaykumar" <[email-masked]>
Date: Thu, 6 Sep 2001 08:54:00 +0530

Hello everybody,
			I want some more details regarding the ASN.1 syntax
for representing S/MIME content.
		
Earlier discussion:

> 1.What is the ASN.1 syntax used for representing a S/MIME content ? For
IPM, 
> the ASN.1 syntax is defined in X.420. For EDI, the syntax is X.435. Are
there 
> any similar representations defined for S/MIME content ?

You will find the ASN.1 syntax in RFC 2630 (CMS) and RFC 2634 (ESS)
-----------
My question:

Those RFCs only define the syntax for the "CMS" object. But how does
one insert that object into an X.400 Content? What will be the ASN.1
syntax of the X.400 Content that will contain the CMS object?
Would it be like this?
--------------------------------------------------------------
OM_CLASS [OM_S_OBJECT_IDENTIFIER_STRING]: MH_C_DELIV_MESSAGE
MH_T_CONTENT [OM_S_OBJECT]: (Object)
      OM_CLASS [OM_S_OBJECT_IDENTIFIER_STRING]: "NEW S-MIME CONTENT"
      MH_T_BINARY_CONTENT [OM_S_OCTET_STRING]:
ContentInfo ::= SEQUENCE {						| C
  contentType ContentType,						| M

  content [0] EXPLICIT ANY DEFINED BY contentType }    	| S
	
| OBJECT
ContentType ::= OBJECT IDENTIFIER					|
-------------------------------------------------------------------

Thanks and regards,
Vijay Hegde

Vijay,
    
> I have a couple of queries regarding
"draft-ietf-smime-x400transport-03.txt".

> 1.What is the ASN.1 syntax used for representing a S/MIME content ? For
IPM, 
> the ASN.1 syntax is defined in X.420. For EDI, the syntax is X.435. Are
there 
> any similar representations defined for S/MIME content ?

You will find the ASN.1 syntax in RFC 2630 (CMS) and RFC 2634 (ESS)

> 2. We use XAPI defined by X/OPEN to build the messages. Are there any 
> OID's/integer value defined to represent S/MIME content. i.e. the value
for 
> MH_T_CONTENT_TYPE. Also, are you aware of any plans on behalf of X/OPEN to

> support S/MIME, these drafts ?

Here are the definitions are you might see them in the X/APIs. 
They are aligned with the latest draft.

/* Content Identifiers */
#define OMP_O_MM_CTO_CMS
"\x2A\x86\x48\x86\xF7\x0D\x01\x09\x10\x01\x06"
#define OMP_O_MM_CTO_MIMECMS          "\x2A\x86\x48\x86\xF7\x0D\x01\x07\x01"

You want to use the first for S/MIME wrapped X.400 content.

I don't know of X/OPEN doing anything to specifically support CMS. 
The above definitions, with a binary content, is sufficient (at least for
me).

Graeme